﻿using Newtonsoft.Json;
using Syncfusion.EJ.PdfViewer;
using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.IO;
using System.Web;
using System.Web.Http;

namespace PdfViewer_MVCsample.Controllers
{
    public class PdfViewerController : ApiController
    {        
        [HttpPost]      
        public object Load(Dictionary<string, string> jsonResult)
        {
            PdfViewerHelper helper = new PdfViewerHelper();
            if (jsonResult.ContainsKey("newFileName"))
            {
                var name = jsonResult["newFileName"];
                var pdfName = name.ToString() + ".pdf";
                helper.Load(HttpContext.Current.Server.MapPath("~/Data/" + pdfName));                             
            }
            else
            {
                if (jsonResult.ContainsKey("isInitialLoading"))
                {
                    if (jsonResult.ContainsKey("file"))
                    {
                        var name = jsonResult["file"];
                        var pdfName = name.ToString();
                        helper.Load(pdfName);
                    }
                    else
                    {
                        helper.Load(HttpContext.Current.Server.MapPath("~/Data/FormFillingDocument1.pdf"));                      
                    }
                }
            }
            string output = JsonConvert.SerializeObject(helper.ProcessPdf(jsonResult));
            return output;                       
        }

        [HttpPost]
        public object Download(Dictionary<string, string> jsonResult)
        {
           PdfViewerHelper helper = new PdfViewerHelper();     
            object pdfData = (object)helper.GetDocumentData(jsonResult);
            var propertyInfo = pdfData.GetType().GetProperty("documentStream");
            string value = propertyInfo.GetValue(pdfData, null).ToString();
            byte[] byteContents = Convert.FromBase64String(value);
            // First, get the empty, unfilled version of the document
            PdfLoadedDocument loadedDocument = new PdfLoadedDocument(byteContents);
            foreach (PdfLoadedField field in loadedDocument.Form.Fields)
            {
                if (field is PdfLoadedTextBoxField)
                {
                    ((PdfLoadedTextBoxField)field).Text = "1";
                }
            }

            loadedDocument.Save(HttpContext.Current.Server.MapPath("~/Data/FormDocument.pdf"));
            loadedDocument.Close(true);
            return helper.GetDocumentData(jsonResult);
        }

        [HttpPost]
        public object FileUpload(Dictionary<string, string> jsonResult)
        {
          PdfViewerHelper helper = new PdfViewerHelper();
            if (jsonResult.ContainsKey("uploadedFile"))
            {
                var fileurl = jsonResult["uploadedFile"];
                byte[] byteArray = Convert.FromBase64String(fileurl);
                MemoryStream stream = new MemoryStream(byteArray);
                helper.Load(stream);
            }
            string output = JsonConvert.SerializeObject(helper.ProcessPdf(jsonResult));
            return output;
        }
        //Post action for unloading and disposing the PDF document resources in server side from the ejPdfviewer widget.
        public void Unload()
        {
            PdfViewerHelper helper = new PdfViewerHelper();
            helper.UnLoad();
        }       
    }
}
